/* [cmd_lim.c] Scanner table for 'cmd'  */

#include "scn_io.h"

#include "scn_imp.h"

static short StaEdg[41] =
/* first edge per state */
{
    0,  38,  39,  40,  43,  45,  46,  47,  60,  65,
   78,  79,  84,  89,  92, 101, 108, 117, 118, 138,
  139, 159, 164, 165, 172, 179, 186, 195, 200, 205,
  208, 211, 222, 232, 235, 240, 243, 246, 255, 258,
  259
};

static short StaFin[40] =
/* finite token per state */
{
    0,   2,   3,   0,   4,   1,  10,   0,   6,   0,
    5,   0,  10,   8,   8,   7,   7,  12,   0,  11,
    0,  15,  13,   9,   9,   0,   7,   0,   0,   0,
    9,   7,   0,   0,   0,   0,   0,   0,   0,  14
};

static wc_char EdgeC[259] =
/* lowest character per edge */
{ /*State*/
  /*   0 */        255,        128,        127,        126,        125,        124,        123,        101,
                   100,         97,         96,         94,         93,         92,         91,         65,
                    58,         49,         48,         47,         46,         45,         42,         40,
                    39,         36,         35,         34,         33,         32,         27,         26,
                    14,         13,         12,         11,         10,          0,
  /*   1 */          0,
  /*   2 */          0,
  /*   3 */         11,         10,          0,
  /*   4 */        256,          0,
  /*   5 */          0,
  /*   6 */          0,
  /*   7 */        255,        128,        127,         97,         96,         93,         92,         40,
                    39,         35,         34,         32,          0,
  /*   8 */        255,        128,        127,         32,          0,
  /*   9 */        255,        128,        127,         97,         96,         93,         92,         40,
                    39,         35,         34,         32,          0,
  /*  10 */          0,
  /*  11 */         58,         48,         46,         45,          0,
  /*  12 */         58,         49,         47,         46,          0,
  /*  13 */         58,         48,          0,
  /*  14 */        102,        101,         70,         69,         58,         48,         47,         46,
                     0,
  /*  15 */        123,         97,         91,         65,         58,         48,          0,
  /*  16 */        123,        112,        111,         97,         91,         65,         58,         48,
                     0,
  /*  17 */          0,
  /*  18 */        117,        116,        115,        114,        113,        112,        111,        110,
                   103,         97,         96,         93,         92,         58,         48,         40,
                    39,         35,         34,          0,
  /*  19 */          0,
  /*  20 */        117,        116,        115,        114,        113,        112,        111,        110,
                   103,         97,         96,         93,         92,         58,         48,         40,
                    39,         35,         34,          0,
  /*  21 */        255,        128,        127,         32,          0,
  /*  22 */          0,
  /*  23 */        102,        101,         70,         69,         58,         48,          0,
  /*  24 */        102,        101,         70,         69,         58,         49,          0,
  /*  25 */         58,         49,         46,         45,         44,         43,          0,
  /*  26 */        123,        100,         99,         97,         91,         65,         58,         48,
                     0,
  /*  27 */        103,         97,         58,         48,          0,
  /*  28 */        103,         97,         58,         48,          0,
  /*  29 */         58,         49,          0,
  /*  30 */         58,         48,          0,
  /*  31 */        123,         97,         91,         65,         58,         48,         14,         13,
                    11,         10,          0,
  /*  32 */        100,         99,         33,         32,         14,         13,         12,         11,
                    10,          0,
  /*  33 */         11,         10,          0,
  /*  34 */         14,         13,         11,         10,          0,
  /*  35 */         33,         32,          0,
  /*  36 */        112,        111,          0,
  /*  37 */        255,        128,        127,         32,         14,         13,         11,         10,
                     0,
  /*  38 */        101,        100,          0,
  /*  39 */          0
};

static short EdgeS[259] =
/* follow (state+1) per edge */
{ /*State*/
  /*   0 */   0,   7,   0,   7,  11,   7,  11,  16,  17,  16,
              0,   7,  11,   0,  11,  16,   7,  15,  14,   7,
             13,  12,   7,  11,  10,   7,   9,   8,   7,   6,
              0,   5,   0,   4,   3,   0,   2,   0,
  /*   1 */   0,
  /*   2 */   0,
  /*   3 */   0,   2,   0,
  /*   4 */   0,   5,
  /*   5 */   0,
  /*   6 */   0,
  /*   7 */   0,   8,   0,   8,   0,   8,  19,   8,   0,   8,
             18,   8,   0,
  /*   8 */   0,   9,   0,   9,   0,
  /*   9 */   0,  10,   0,  10,   0,  10,  21,  10,  20,  10,
              0,  10,   0,
  /*  10 */   0,
  /*  11 */   0,  14,   0,  22,   0,
  /*  12 */   0,  24,   0,  23,   0,
  /*  13 */   0,  14,   0,
  /*  14 */   0,  26,   0,  26,   0,  15,   0,  25,   0,
  /*  15 */   0,  16,   0,  16,   0,  16,   0,
  /*  16 */   0,  16,  27,  16,   0,  16,   0,  16,   0,
  /*  17 */   0,
  /*  18 */   0,   8,   0,   8,   0,   8,   0,   8,   0,  28,
              8,   0,   8,   0,  28,   0,   8,   0,   8,   0,
  /*  19 */   0,
  /*  20 */   0,  10,   0,  10,   0,  10,   0,  10,   0,  29,
             10,   0,  10,   0,  29,   0,  10,   0,  10,   0,
  /*  21 */   0,  22,   0,  22,   0,
  /*  22 */   0,
  /*  23 */   0,  26,   0,  26,   0,  24,   0,
  /*  24 */   0,  26,   0,  26,   0,  24,   0,
  /*  25 */   0,  31,   0,  30,   0,  30,   0,
  /*  26 */   0,  16,  32,  16,   0,  16,   0,  16,   0,
  /*  27 */   0,   8,   0,   8,   0,
  /*  28 */   0,  10,   0,  10,   0,
  /*  29 */   0,  31,   0,
  /*  30 */   0,  31,   0,
  /*  31 */   0,  16,   0,  16,   0,  16,   0,  34,   0,  33,
              0,
  /*  32 */   0,  37,   0,  36,   0,  34,  35,   0,  33,   0,
  /*  33 */   0,  33,   0,
  /*  34 */   0,  34,   0,  33,   0,
  /*  35 */   0,  38,   0,
  /*  36 */   0,  39,   0,
  /*  37 */   0,  38,   0,  38,   0,  34,   0,  33,   0,
  /*  38 */   0,  40,   0,
  /*  39 */   0
};

static string Tokens[16] =
/* token -> string */
{
  "[other]",
  "Space",
  "Line",
  "Page",
  "Etx",
  "Parenthesis",
  "Comment",
  "Ide",
  "Int",
  "Flo",
  "Opr",
  "Set",
  "Seq",
  "Pth",
  "Doc",
  "Dol"
};

static byte Flags[16] =
/* token -> newid */
{
  0x00, 0x01, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

static ConcreteImp(scn_t) Scanner =
/* the scanner structure */
{
  "cmd", /* Name    */
  40,    /* States  */
  16,    /* Tokens  */
  StaEdg,
  StaFin,
  EdgeC,
  EdgeS,
  Tokens,
  Flags,
};

void Scn_get_cmd(Scn_T *scn)
/* simulates a Scn_get */
{
  *scn = Scn_copy(Scn_ADT(&Scanner));
};
