/* ------------------------------------------------------------------------ */
/*                                                                          */
/* [lim_test.c]                  Scanner Test                               */
/*                                                                          */
/* Copyright (c) 1993 by D\olle, Manns                                      */
/* ------------------------------------------------------------------------ */

#include "stdosx.h"
#include "scn_base.h"

#include "lim__cim.h"

int main(int argc, string argv[])
{ Scn_Stream stream; Scn_T scn; int i, maxlen;

  CTX_init_lim_test(argc,argv);
  initSymbols();
  /* get the scanner */
  Scn_get(CTX_EVAL(string,"Language"), &scn);
  /* prepare layout */
  maxlen = 0;
  for (i = 0; i < Scn_tokens(scn); i++)
  { string s = Scn_tokid(scn,i);
    maxlen = MAX(maxlen, strlen(s));
    FreeMem(s);
  }
  /* actual scanning */
  stream = Stream_file(scn, "", CTX_EVAL(string,"FileName"), "");
  Stream_defEofId(stream,-1);
  Stream_defErrId(stream, 0);
  for (i = 1; i < Scn_tokens(scn); i++)
  { string s = Scn_tokid(scn,i);
    Stream_defTokId( stream, s, (short)i );
    FreeMem(s);
  }
  for
  (
    Stream_next(stream);
    Stream_ctid(stream) >= 0;
    Stream_next(stream)
  )
  if (CTX_EVAL(bool,"tokens"))
  { string s = Scn_tokid(scn,Stream_ctid(stream));
    printf
    (
      "%s:%03d:%03d %s%*s : %s\n",
      symbolToString(Stream_cfil(stream)),
      Stream_clin(stream),
      Stream_ccol(stream),
      s,
      maxlen - strlen(s), "",
      symbolToString(Stream_csym(stream))
    );
    FreeMem(s);
  }
  Stream_close(stream);
  Stream_free(stream);
  Scn_free(scn);
  if (CTX_EVAL(bool,"symbols")) { NL; printSymbols(0); NL; }
  freeSymbols();
  CTX_quit();
  BUG_CORE;
  return(0);
}
