/* ------------------------------------------------------------------------ */
/*                                                                          */
/* [pim_test.c]                  Parser Test                                */
/*                                                                          */
/* Copyright (c) 1993 by D\olle, Manns                                      */
/* ------------------------------------------------------------------------ */

#include "stdosx.h"
#include "scn_base.h"
#include "scn_pre.h"
#include "prs.h"
#include "ptm.h"
#include "ptm_gen.h"
#include "pathes.h"
#include "symbols.h"
#include "hmap.h"

#include "pim__cim.h"

#define start    CTX_EVAL(string,"Start")
#define language CTX_EVAL(string,"Language")
#define filename CTX_EVAL(string,"FileName")
#define prepar   CTX_EVAL(string,"prepar")
#define tree     CTX_EVAL(bool,"tree")
#define xaron    CTX_EVAL(bool,"xaron")

int main(int argc, string argv[])
{ PLR_Tab PTab; Scn_T Scn; Scn_Stream cStream; 
  PT_Cfg PCfg; PT_Term PTree;
  MAP(long,symbol) pPreParMap;
  CTX_init_pim_test(argc,argv);
  initSymbols();
  MAP_init();
  if( strlen(prepar) > 0 )
  { c_string szS, szT; PIT pItr; 
    pPreParMap = MAP_newPrimMap();
    pItr = PIT_make(prepar); 
    PIT_sep(pItr,",");
    while( ( szS = PIT_read(pItr) ) != NULL )
    {
      szT = strstr(szS,"~");
      if( szT != (c_string)NULL )
      {
        *szT = '\0';
        MAP_dfndom(pPreParMap,atol(szS),stringToSymbol(szT+1));
        *szT = '~';
      }
    }
    PIT_drop(pItr);
    SPP_init(pPreParMap);
  }
  Scn_get(language,&Scn);
  cStream = Stream_file(Scn,"",filename,"");
  if( strlen(prepar) > 0 )
    Stream_premac_set(cStream, SPP_premac);
  PTab    = PLR_getTab(language);
  PCfg    = PT_init(PTab,cStream);
  if( ! xaron ) PTree = PT_PARSE(PCfg,start);
  else          PTree = XPT_PARSE(PCfg,start);
  PT_quit(PCfg);
  if( tree ) PT_print(PTree);
  Stream_close(cStream);
  Stream_free(cStream);
  Scn_free(Scn);
  PLR_delTab(PTab);
  PT_delT(PTree);
  if( strlen(prepar) > 0 )
  {
    MAP_freeMap(pPreParMap);
    SPP_quit();
  }
  MAP_quit();
  freeSymbols();
  CTX_quit();
  BUG_CORE;
  return(0);
}
