/* ------------------------------------------------------------------------ */
/*                                                                          */
/* [ptm_img.c]             Put&Get Term                                     */
/*                                                                          */
/* Copyright (c) 1993 by D\olle, Manns                                      */
/* ------------------------------------------------------------------------ */

#include "stdosx.h"
#include "scn_base.h"
#include "prs.h"
#include "ptm.h"
#include "ptm_gen.h"
#include "binimg.h"
#include "sink.h"

#include "ptm__cim.h"

#define start    CTX_EVAL(string,"Start")
#define img      CTX_EVAL(string,"Img")
#define language CTX_EVAL(string,"Language")
#define filename CTX_EVAL(string,"FileName")
#define xaron    CTX_EVAL(bool,"xaron")

int main(int argc, string argv[])
{ PLR_Tab PTab; PT_Term PTree;
  CTX_init_ptm_img(argc,argv);
  initSymbols();
  PTab = PLR_getTab(language);
  if( strlen(filename) ) 
  { string s = Str_printf("[%s] Binary %s Derivation Tree",img,language);
    Scn_T Scn; Scn_Stream cStream; PT_Cfg PCfg;
    Scn_get(language,&Scn);
    cStream = Stream_file(Scn,"",filename,"");
    PCfg    = PT_init(PTab,cStream);
    if( ! xaron ) PTree = PT_PARSE(PCfg,start);
    else          PTree = XPT_PARSE(PCfg,start);
    PT_quit(PCfg);
    if( PTree != (PT_Term)NULL )
    {
      putBgn("",img,"");
      putHeader(s,"ptmimg",1,0);
      putReference(PTree,PT_putT);
      putEnd();
    }
    Stream_close(cStream);
    Stream_free(cStream);
    Scn_free(Scn);
    FreeMem(s);
  }
  else
  { 
    getBgn("",img,"");
    getHeader("ptmimg",1,0);
    getReference(&PTree,PT_getT);
    getEnd();
    PT_print(PTree);
  }
  PLR_delTab(PTab);
  PT_delT(PTree);
  freeSymbols();
  CTX_quit();
  BUG_CORE;
  return(0);
}
